## frobby 0.9.0

=== Makefile ===
# ***** Variables

rawSources := main.cpp Action.cpp IOParameters.cpp						\
  IrreducibleDecomAction.cpp fplllIO.cpp IOHandler.cpp fourti2.cpp		\
  randomDataGenerators.cpp MonosIOHandler.cpp BigIdeal.cpp				\
  TransformAction.cpp Macaulay2IOHandler.cpp NewMonosIOHandler.cpp		\
  HelpAction.cpp stdinc.cpp DynamicFrobeniusAction.cpp					\
  dynamicFrobeniusAlgorithm.cpp GenerateIdealAction.cpp					\
  GenerateFrobeniusAction.cpp intersect.cpp FrobeniusAction.cpp			\
  Facade.cpp IOFacade.cpp DynamicFrobeniusFacade.cpp					\
  GenerateDataFacade.cpp AnalyzeAction.cpp IdealFacade.cpp				\
  Parameter.cpp ParameterGroup.cpp IntegerParameter.cpp					\
  SliceParameters.cpp BoolParameter.cpp Scanner.cpp Partition.cpp		\
  StringParameter.cpp Term.cpp TermTranslator.cpp Timer.cpp				\
  VarNames.cpp LatticeFormatAction.cpp Ideal.cpp						\
  IntersectionAction.cpp IntersectFacade.cpp							\
  AssociatedPrimesAction.cpp MsmSlice.cpp IndependenceSplitter.cpp		\
  Projection.cpp MsmStrategy.cpp lattice.cpp LatticeFacade.cpp			\
  DecomRecorder.cpp TermGrader.cpp Fourti2IOHandler.cpp					\
  NullIOHandler.cpp Minimizer.cpp AlexanderDualAction.cpp frobby.cpp	\
  BigTermConsumer.cpp TranslatingTermConsumer.cpp HilbertAction.cpp		\
  HilbertSlice.cpp Polynomial.cpp CanonicalCoefTermConsumer.cpp			\
  HilbertStrategy.cpp Slice.cpp SliceStrategyCommon.cpp					\
  DebugStrategy.cpp OptimizeStrategy.cpp SliceFacade.cpp				\
  BigTermRecorder.cpp CoCoA4IOHandler.cpp SingularIOHandler.cpp			\
  TotalDegreeCoefTermConsumer.cpp BigPolynomial.cpp						\
  CoefBigTermRecorder.cpp PolyTransformAction.cpp VarSorter.cpp			\
  TermConsumer.cpp NullTermConsumer.cpp CoefTermConsumer.cpp			\
  NullCoefTermConsumer.cpp TranslatingCoefTermConsumer.cpp				\
  PolynomialFacade.cpp HilbertBasecase.cpp								\
  HilbertIndependenceConsumer.cpp SplitStrategy.cpp						\
  CanonicalTermConsumer.cpp StatisticsStrategy.cpp TestAction.cpp		\
  NameFactory.cpp error.cpp DebugAllocator.cpp FrobbyStringStream.cpp	\
  SliceStrategy.cpp PrimaryDecomAction.cpp IdealComparator.cpp			\
  IrreducibleIdealSplitter.cpp DataType.cpp IdealConsolidator.cpp		\
  CoefBigTermConsumer.cpp PolynomialConsolidator.cpp					\
  OptimizeAction.cpp MaximalStandardAction.cpp test/Test.cpp			\
  test/TestCase.cpp test/TestQualifier.cpp test/TestRunner.cpp			\
  test/TestSuite.cpp test/TestVisitor.cpp test/macroes.cpp				\
  test/asserts.cpp IdealFactory.cpp PolynomialFactory.cpp				\
  LatticeAnalyzeAction.cpp SatBinomIdeal.cpp SatBinomConsumer.cpp		\
  SatBinomRecorder.cpp CountingIOHandler.cpp test/TestSorter.cpp		\
  DimensionAction.cpp SizeMaxIndepSetAlg.cpp TaskEngine.cpp Task.cpp	\
  BigattiHilbertAlgorithm.cpp BigattiState.cpp ObjectCache.cpp			\
  HashPolynomial.cpp BigattiBaseCase.cpp BigattiPivotStrategy.cpp		\
  BigattiFacade.cpp UniHashPolynomial.cpp CommonParams.cpp				\
  CliParams.cpp SliceParams.cpp SliceLikeParams.cpp BigattiParams.cpp	\
  IOHandlerImpl.cpp IdealWriter.cpp PolyWriter.cpp IOHandlerCommon.cpp	\
  CommonParamsHelper.cpp ActionPrinter.cpp ScarfHilbertAlgorithm.cpp	\
  ScarfFacade.cpp Deformer.cpp IdealTree.cpp TermPredicate.cpp			\
  ScarfParams.cpp IdealOrderer.cpp TermExtra.cpp display.cpp			\
  Matrix.cpp BigIntVector.cpp ColumnPrinter.cpp EulerAction.cpp			\
  RawSquareFreeTerm.cpp RawSquareFreeIdeal.cpp PivotEulerAlg.cpp		\
  EulerState.cpp PivotStrategy.cpp Arena.cpp LocalArray.cpp				\
  LatticeAlgs.cpp InputConsumer.cpp SquareFreeIdeal.cpp

rawTests := LibAlexanderDualTest.cpp LibHilbertPoincareTest.cpp			\
  LibIrreducibleDecomTest.cpp LibMaxStdTest.cpp LibStdProgramTest.cpp	\
  LibTest.cpp OptimizeStrategyTest.cpp TermTest.cpp						\
  TermTranslatorTest.cpp RawSquareFreeTermTest.cpp						\
  RawSquareFreeIdealTest.cpp LibPrimaryDecomTest.cpp					\
  LibAssociatedPrimesTest.cpp MatrixTest.cpp IdealTest.cpp				\
  LibDimensionTest.cpp TermGraderTest.cpp ArenaTest.cpp

ifndef CXX
  CXX      = "g++"
endif

ifndef BIN_INSTALL_DIR
  BIN_INSTALL_DIR = "/usr/local/bin/"
endif

cflags = $(CFLAGS) $(CPPFLAGS) -Wall -ansi -pedantic -I $(GMP_INC_DIR)	\
         -Wno-uninitialized -Wno-unused-parameter
program = frobby
library = libfrobby.a
benchArgs = $(FROBBYARGS)

ifndef MODE
 MODE=release
endif

ifndef ldflags
  ldflags = $(cflags) $(LDFLAGS) -lgmpxx -lgmp
endif

MATCH=false
ifeq ($(MODE), release)
  outdir = bin/release/
  cflags += -O2
  MATCH=true
endif
ifeq ($(MODE), debug)
  rawSources := $(rawSources) $(rawTests)
  outdir = bin/debug/
  cflags += -g -D DEBUG -fno-inline -Werror -Wextra -Wno-uninitialized \
            -Wno-unused-parameter
  MATCH=true
endif
ifeq ($(MODE), shared)
  outdir = bin/shared/
  cflags += -O2 -fPIC
  library = libfrobby.so
  MATCH=true
endif
ifeq ($(MODE), profile)
  outdir = bin/profile/
  cflags += -g -pg -O2 -D PROFILE
  ldflags += -pg
  MATCH=true
  benchArgs = _profile $(FROBBYARGS)
endif
ifeq ($(MODE), analysis)
  rawSources := $(rawSources) $(rawTests)
  outdir = bin/analysis/
  cflags += -Wextra -fsyntax-only -O1 -Wfloat-equal -Wundef				\
  -Wno-endif-labels -Wshadow -Wlarger-than-1000 -Wpointer-arith			\
  -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wsign-compare	\
  -Waggregate-return -Wmissing-noreturn -Wmissing-format-attribute		\
  -Wno-multichar -Wno-deprecated-declarations -Wpacked					\
  -Wno-redundant-decls -Wunreachable-code -Winline						\
  -Wno-invalid-offsetof -Winvalid-pch -Wlong-long						\
  -Wdisabled-optimization -D DEBUG -Werror
  MATCH=true
endif

ifeq ($(MATCH), false)
  $(error Unknown value of MODE: "$(MODE)")
endif

sources = $(patsubst %.cpp, src/%.cpp, $(rawSources))
objs    = $(patsubst %.cpp, $(outdir)%.o, $(rawSources))

# ***** Compilation

.PHONY: all depend clean bin/$(program) test library distribution clear fixspace

all: bin/$(program) $(outdir)$(program)

# ****************** Testing
# use TESTARGS of
#  _valgrind to run under valgrind.
#  _debugAlloc to test recovery when running out of memory.
#  _full to obtain extra tests by verifying relations
#    between outputs of different actions, and generally testing
#    everything that can be tested.
# _full cannot follow the other options because it is picked up at an earlier
# point in the test system than they are. There are more options - see
# test/testScripts/testhelper for a full list.
#
# Only miniTest and bareTest support TESTARGS, and some options are not
# available unless MODE=debug.

# The correct choice to do a reasonably thorough test of an
# installation of Frobby.
test: all
	test/runTests

# Run all tests that it makes sense to run.
fullTest: all
	test/runTests _full
	test/runSplitTests _full

# Good for testing Frobby after a small change.
microTest: all
	test/runTests _few $(TESTARGS)
miniTest: all
	test/runTests $(TESTARGS)

# Runs all tests and allows full control over the arguments.
bareTest: all
	test/runTests $(TESTARGS) 
	test/runSplitTests $(TESTARGS)

# Run benchmarks to detect performance regressions. When MODE=profile,
# profile files for the benchmarked actions will be placed in bin/.
bench: all
	cd test/bench; ./runbench $(benchArgs)
benchHilbert: all
	cd test/bench; ./run_hilbert_bench $(benchArgs)
benchOptimize: all
	cd test/bench; ./run_optimize_bench $(benchArgs)
benchAlexdual: all
	cd test/bench; ./run_alexdual_bench $(benchArgs)

bin/:
	mkdir bin/;

# Make symbolic link to program from bin/
bin/$(program): $(outdir)$(program) bin/
ifneq ($(MODE), analysis)
	cd bin; rm -f $(program); ln -s ../$(outdir)$(program) $(program); cd ..
endif

# Link object files into executable
$(outdir)$(program): $(objs) | $(outdir)
	@mkdir -p $(dir $@)
ifeq ($(MODE), analysis)
	echo > $@
endif
ifneq ($(MODE), analysis)
	$(CXX) $(objs) $(ldflags) -o $@
	if [ -f $@.exe ]; then \
      mv -f $@.exe $@; \
	fi
endif
ifeq ($(MODE), release)
	strip $@
endif

# Link object files into library
library: bin/$(library)
bin/$(library): $(objs) | bin/
	rm -f bin/$(library)
ifeq ($(MODE), shared)
	$(CXX) -shared -o bin/$(library) $(ldflags) \
	  $(patsubst $(outdir)main.o,,$(objs))
else
	ar crs bin/$(library) $(patsubst $(outdir)main.o,,$(objs))
endif

# Compile and output object files.
# In analysis mode no file is created, so create one
# to allow dependency analysis to work.
$(outdir)%.o: src/%.cpp
	@mkdir -p $(dir $@)
	$(CXX) ${cflags} -c $< -o $@
	$(CXX) $(cflags) -MM -c $< > $(@:.o=.d).tmp
# using /usr/bin/env echo to get the non-built-in echo on OS X, since
# the built-in one does not understand the parameter -n.
	@/usr/bin/env echo -n "$(dir $@)" > $(@:.o=.d)
	@cat $(@:.o=.d).tmp >> $(@:.o=.d)
	@sed -e 's/.*://' -e 's/\\$$//' < $(@:.o=.d).tmp | fmt -1 | \
	  sed -e 's/^ *//' -e 's/$$/:/' >> $(@:.o=.d)
	@rm -f $(@:.o=.d).tmp
ifeq ($(MODE), analysis)
	  echo > $@
endif

-include $(objs:.o=.d)

# Installation.
install:
	if [ "`uname|grep CYGWIN`" = "" ]; then \
		sudo install bin/frobby $(BIN_INSTALL_DIR); \
	else \
		install bin/frobby $(BIN_INSTALL_DIR); \
	fi  # Cygwin has no sudo

# ***** Documentation

# We need to run latex three times to make sure that references are done
# properly in the output.
doc: docPs docPdf
docPs:
	rm -rf bin/doc
	mkdir bin/doc
	for i in 1 2 3; do latex -output-directory=bin/doc/ doc/manual.tex; done
	cd bin; dvips doc/manual.dvi
docPdf:
	rm -rf bin/doc
	mkdir bin/doc
	for i in 1 2 3; do pdflatex -output-directory=bin/doc/ doc/manual.tex; done
	mv bin/doc/manual.pdf bin
docDviOnce: # Useful to view changes when writing the manual
	latex -output-directory=bin/doc doc/manual.tex

# It may seem wasteful to run doxygen three times to generate three
# kinds of output. However, the latex output for creating a pdf file
# and for creating a PostScript file is different, and so at least two
# runs are necessary. Making the HTML output a third run is cleaner
# than tacking it onto one or both of the other two targets.
bin/develDoc/: bin/
	mkdir bin/develDoc
develDoc: develDocHtml develDocPdf develDocPs
develDocHtml: bin/develDoc/
	cat doc/doxygen.conf doc/doxHtml|doxygen -
develDocPdf: bin/develDoc/
	rm -rf bin/develDoc/latexPdf bin/develDoc/warningLog
	cat doc/doxygen.conf doc/doxPdf|doxygen -
	cd bin/develDoc/latexPdf; for f in `ls *.eps`; do epstopdf $$f; done # Cygwin fix
	cd bin/develDoc/latexPdf/; make refman.pdf; mv refman.pdf ../develDoc.pdf
develDocPs: bin/develDoc/
	rm -rf bin/develDoc/latexPs bin/develDoc/warningLog
	cat doc/doxygen.conf doc/doxPs|doxygen -
	cd bin/develDoc/latexPs/; make refman.ps; mv refman.ps ../develDoc.ps

clean: tidy
	rm -rf bin

# ***** Miscellaneous

tidy:
	find .|grep -x ".*~\|.*/\#.*\#|.*\.stackdump\|gmon\.out\|.*\.orig\|.*/core\|core"|xargs rm -f

# Fixes various white space related issues.
fixspace:
	find src/ doc/ -type f|xargs ./fixspace;

commit: test
	echo
	hg commit -m "$(MSG)"

# ***** Distribution

remoteUrl = ssh://daimi/projs/frobby
pull:
	hg pull $(remoteUrl)
push:
	hg push $(remoteUrl)

distribution:
ifndef VER
	echo "Please specify version of Frobby distribution using VER=x.y.z";
	exit 1;
endif
	rm -fr frobby_v$(VER).tar.gz frobby_v$(VER)
	mkdir frobby_v$(VER)
	cp -r changelog.txt frobgrob COPYING Makefile src test doc frobby_v$(VER)
	mkdir frobby_v$(VER)/4ti2
	tar --create --gzip --file=frobby_v$(VER).tar.gz frobby_v$(VER)/
	rm -fr frobby_v$(VER)	
	ls -l frobby_v$(VER).tar.gz

spkg: tidy depend
ifndef VER
	echo "Please specify version of Frobby spkg using VER=x.y.z";
	exit 1;
endif
	if [ "$$SAGE_LOCAL" = "" ]; then \
	  echo "SAGE_LOCAL undefined ... exiting"; \
	  echo "Maybe run 'sage -sh?'" \
	  exit 1; \
	fi

	if [ ! -d sage/ ]; then echo "sage/ directory not found."; exit 1; fi
# Ensure that previous builds have been cleaned up
	rm -rf bin/sagetmp bin/frobby-$(VER) bin/frobby-$(VER).spkg

	hg clone sage bin/sagetmp

	mkdir bin/sagetmp/src
	cp -r COPYING Makefile src test bin/sagetmp/src

	mv bin/sagetmp bin/frobby-$(VER)
	cd bin/; $(SAGE_ROOT)/sage -pkg `pwd`/frobby-$(VER)
	rm -rf bin/frobby-$(VER)

=== debian/changelog ===
frobby (0.9.0-5) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.1.0.
    - Expand Description.
  * debian/rules
    - Disable parallel builds (Closes: #873426).
    - Set FORCE_SOURCE_DATE macro for reproducible builds of manual.
  * debian/watch
    - Bump to uscan 4 and use special strings.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 27 Aug 2017 20:00:04 -0400

frobby (0.9.0-4) unstable; urgency=medium

  * debian/control
    - Move all dependencies back to Build-Depends. Some documentation
      is shipped with the architecture-dependent package frobby, and
      so we need these dependencies on all architectures
      (Closes: #872020).

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 13 Aug 2017 19:56:10 -0400

frobby (0.9.0-3) unstable; urgency=medium

  * debian/compat
    - Bump dephelper compatibility level to 10.
  * debian/control
    - Tidy up using wrap-and-sort.
    - Bump Standards-Version to 4.0.1.
    - Bump versioned dependency on debhelper to >= 10.
    - Add g++ (>= 4:7) to Build-Depends.
    - Add Build-Depends-Indep.
    - Use https protocol for Vcs-Browser.
    - Remove libfrobby-dbg in favor of automatically generated *-dbgsym
      packages.
  * debian/copyright
    - Update Format with https.
  * debian/patches/fix_test.patch
    - New patch; fix typo in test script by using '=' instead of '=='
      for string comparison.
  * debian/patches/fix_typos.patch
    - New patch; fix spelling errors.
  * debian/patches/reproducible_build.patch
    - New patch; remove \today macro from manual to allow for
      reproducible builds.
  * debian/rules
    - Update override_dh_strip target; use --dbgsym-migration.
    - Add override_dh_makeshlibs target to generate tight dependency
      due to GCC 7 transition (Closes: #871280).
  * debian/tests
    - Add autopkgtest support.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sat, 12 Aug 2017 23:36:41 -0400

frobby (0.9.0-2) unstable; urgency=medium

  * debian/{control,copyright,frobby.1,patches}
    - Update email address.

 -- Doug Torrance <dtorrance@piedmont.edu>  Thu, 03 Sep 2015 07:30:35 -0400

frobby (0.9.0-1) unstable; urgency=low

  * Initial release (Closes: #780548).

 -- Doug Torrance <dtorrance@monmouthcollege.edu>  Thu, 19 Mar 2015 11:54:58 -0500

=== debian/control ===
Source: frobby
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Doug Torrance <dtorrance@piedmont.edu>
Build-Depends: debhelper (>= 10),
               dh-exec,
               doxygen,
               g++ (>= 4:7),
               ghostscript,
               libgmp-dev,
               texlive-font-utils,
               texlive-fonts-recommended,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-latex-recommended
Standards-Version: 4.1.0
Homepage: http://www.broune.com/frobby/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/frobby.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/frobby.git

Package: frobby
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: Computations with monomial ideals
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
 is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.

Package: libfrobby0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Computations with monomial ideals (shared library)
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
 is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.
 .
 This package contains the shared library.

Package: libfrobby-dev
Section: libdevel
Architecture: any
Depends: libfrobby0 (=${binary:Version}), ${misc:Depends}
Recommends: libfrobby-doc (=${binary:Version})
Multi-Arch: same
Description: Computations with monomial ideals (development tools)
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
 is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.
 .
 This package contains the development tools.

Package: libfrobby-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Computations with monomial ideals (library documentation)
 Frobby is a software system and project for computations with monomial ideals.
 Frobby is free software and it is intended as a vehicle for computational and
 mathematical research on monomial ideals.
 .
 The current functionality includes Euler characteristic, Hilbert series,
 maximal standard monomials, combinatorial optimization on monomial ideals,
 primary decomposition, irreducible decomposition, Alexander dual, associated
 primes, minimization and intersection of monomial ideals as well as the
 computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
 is also able to translate between formats that can be used with several
 different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
 Singular. Thus Frobby can be used with any of those systems.
 .
 This package contains the library documentation.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,-soname,libfrobby.so.0

# for reproducible builds of manual
export FORCE_SOURCE_DATE = 1

%:
	dh $@ --no-parallel

override_dh_auto_build:
	dh_auto_build -- all library doc develDoc \
		MODE=shared library=libfrobby.so.0.0.0

override_dh_auto_install:
	dh_auto_install -- BIN_INSTALL_DIR=/usr/bin

override_dh_strip:
	dh_strip --dbgsym-migration='libfrobby-dbg (<< 0.9.0-3~)'

override_dh_makeshlibs:
	dh_makeshlibs -V'libfrobby0 (>= 0.9.0-3~)'

=== debian/tests/control ===
Tests: runtests
Depends: frobby

=== debian/watch ===
version=4
http://www.broune.com/frobby/frobby_v@ANY_VERSION@@ARCHIVE_EXT@

## frobby 0.9.1

=== Makefile ===
--- 
+++ 
@@ -70,8 +70,7 @@
   BIN_INSTALL_DIR = "/usr/local/bin/"
 endif
 
-cflags = $(CFLAGS) $(CPPFLAGS) -Wall -ansi -pedantic -I $(GMP_INC_DIR)	\
-         -Wno-uninitialized -Wno-unused-parameter
+cxxflags = $(CXXFLAGS) $(CPPFLAGS) -I $(GMP_INC_DIR) -Wno-uninitialized -Wno-unused-parameter
 program = frobby
 library = libfrobby.a
 benchArgs = $(FROBBYARGS)
@@ -81,31 +80,31 @@
 endif
 
 ifndef ldflags
-  ldflags = $(cflags) $(LDFLAGS) -lgmpxx -lgmp
+  ldflags = $(LDFLAGS) -lgmpxx -lgmp
 endif
 
 MATCH=false
 ifeq ($(MODE), release)
   outdir = bin/release/
-  cflags += -O2
+  cxxflags += -O2
   MATCH=true
 endif
 ifeq ($(MODE), debug)
   rawSources := $(rawSources) $(rawTests)
   outdir = bin/debug/
-  cflags += -g -D DEBUG -fno-inline -Werror -Wextra -Wno-uninitialized \
+  cxxflags += -g -D DEBUG -fno-inline -Werror -Wextra -Wno-uninitialized \
             -Wno-unused-parameter
   MATCH=true
 endif
 ifeq ($(MODE), shared)
   outdir = bin/shared/
-  cflags += -O2 -fPIC
+  cxxflags += -O2 -fPIC
   library = libfrobby.so
   MATCH=true
 endif
 ifeq ($(MODE), profile)
   outdir = bin/profile/
-  cflags += -g -pg -O2 -D PROFILE
+  cxxflags += -g -pg -O2 -D PROFILE
   ldflags += -pg
   MATCH=true
   benchArgs = _profile $(FROBBYARGS)
@@ -113,14 +112,14 @@
 ifeq ($(MODE), analysis)
   rawSources := $(rawSources) $(rawTests)
   outdir = bin/analysis/
-  cflags += -Wextra -fsyntax-only -O1 -Wfloat-equal -Wundef				\
-  -Wno-endif-labels -Wshadow -Wlarger-than-1000 -Wpointer-arith			\
-  -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wsign-compare	\
-  -Waggregate-return -Wmissing-noreturn -Wmissing-format-attribute		\
-  -Wno-multichar -Wno-deprecated-declarations -Wpacked					\
-  -Wno-redundant-decls -Wunreachable-code -Winline						\
-  -Wno-invalid-offsetof -Winvalid-pch -Wlong-long						\
-  -Wdisabled-optimization -D DEBUG -Werror
+  cxxflags += -Wextra -fsyntax-only -O1 -Wfloat-equal -Wundef			\
+      -Wno-endif-labels -Wshadow -Wlarger-than-1000 -Wpointer-arith		\
+      -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wsign-compare	\
+      -Waggregate-return -Wmissing-noreturn -Wmissing-format-attribute		\
+      -Wno-multichar -Wno-deprecated-declarations -Wpacked			\
+      -Wno-redundant-decls -Wunreachable-code -Winline				\
+      -Wno-invalid-offsetof -Winvalid-pch -Wlong-long				\
+      -Wdisabled-optimization -D DEBUG -Werror
   MATCH=true
 endif
 
@@ -217,6 +216,7 @@
 	  $(patsubst $(outdir)main.o,,$(objs))
 else
 	ar crs bin/$(library) $(patsubst $(outdir)main.o,,$(objs))
+	$(RANLIB) bin/$(library)
 endif
 
 # Compile and output object files.
@@ -224,8 +224,8 @@
 # to allow dependency analysis to work.
 $(outdir)%.o: src/%.cpp
 	@mkdir -p $(dir $@)
-	$(CXX) ${cflags} -c $< -o $@
-	$(CXX) $(cflags) -MM -c $< > $(@:.o=.d).tmp
+	$(CXX) ${cxxflags} -c $< -o $@
+	$(CXX) $(cxxflags) -MM -c $< > $(@:.o=.d).tmp
 # using /usr/bin/env echo to get the non-built-in echo on OS X, since
 # the built-in one does not understand the parameter -n.
 	@/usr/bin/env echo -n "$(dir $@)" > $(@:.o=.d)

=== debian/changelog ===
frobby (0.9.1-1) unstable; urgency=medium

  * New upstream release.
    - Now maintained by the Macaulay2 developers.
  * debian/control
    - Update Homepage.
  * debian/copyright
    - Update Source.
  * debian/patches
    - Refresh and remove patches applied upstream.
  * debian/upstream/metadata
    - Add upstream metadata file.
  * debian/watch
    - Update download location.

 -- Doug Torrance <dtorrance@piedmont.edu>  Tue, 30 Jun 2020 21:45:18 -0400

frobby (0.9.0-6) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix doxygen requirements
  * Point Vcs fields to salsa.debian.org
  * Better solution for Build-Depends

  [ Doug Torrance ]
  * debian/compat
    - Remove file; no longer necessary now that we Build-Depend on
      debhelper-compat.
  * debian/control
    - Bump Standards-Version to 4.5.0.
    - Switch Build-Depend on debhelper to debhelper-compat.
    - Bump to debhelper compatibility level 13.
    - Set Section for libfrobby0 to libs.
    - Add Rules-Requires-Root field.
  * debian/libfrobby-doc.doc-base
    - Update path to documentation. After debhelper v11, it is installed
      under /usr/share/doc/libfrobby-dev, the path for the "main package".
  * debian/patches/avoid_doxygen_bug.patch
    - New patch to avoid a bug in doxygen which causes build failures.
  * debian/rules
    - Enable all hardening flags.
    - Add override_dh_install target. In particular, skip
      installation of _formula.* for the sake of reproducible
      builds.  Thanks to Chris Lamb <lamby@debian.org> for the
      patch (Closes: #942479).
    - Remove override_dh_strip target. It specified a the
      --dbgsym-migration argument and was added in version 0.9.0-3.
      As version 0.9.0-5 is now in stable, the migration is complete.
    - Adjust override_dh_makeshlibs target. -V option was added for a GCC 7
      transition in package version 0.9.0-3, but 0.9.0-5 is now in stable,
      so it has been removed.  But add an -X option so that the frobby
      executable doesn't trigger ldconfig.
  * debian/salsa-ci.yml
    - Add Salsa pipelines config file.
  * debian/watch
    - Use https.

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 25 May 2020 12:37:28 -0400

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: frobby
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Section: math
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Doug Torrance <dtorrance@piedmont.edu>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                dh-exec,
-               doxygen,
+               doxygen-latex,
                g++ (>= 4:7),
                ghostscript,
                libgmp-dev,
@@ -13,16 +13,18 @@
                texlive-fonts-recommended,
                texlive-latex-base,
                texlive-latex-extra,
-               texlive-latex-recommended
-Standards-Version: 4.1.0
-Homepage: http://www.broune.com/frobby/
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/frobby.git
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/frobby.git
+               texlive-latex-recommended,
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/science-team/frobby
+Vcs-Git: https://salsa.debian.org/science-team/frobby.git
+Homepage: https://github.com/Macaulay2/frobby
+Rules-Requires-Root: no
 
 Package: frobby
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: foreign
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: Computations with monomial ideals
  Frobby is a software system and project for computations with monomial ideals.
  Frobby is free software and it is intended as a vehicle for computational and
@@ -39,9 +41,11 @@
 
 Package: libfrobby0
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
+Section: libs
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Multi-Arch: same
 Description: Computations with monomial ideals (shared library)
  Frobby is a software system and project for computations with monomial ideals.
  Frobby is free software and it is intended as a vehicle for computational and
@@ -59,11 +63,12 @@
  This package contains the shared library.
 
 Package: libfrobby-dev
+Architecture: any
+Multi-Arch: same
 Section: libdevel
-Architecture: any
-Depends: libfrobby0 (=${binary:Version}), ${misc:Depends}
+Depends: libfrobby0 (=${binary:Version}),
+         ${misc:Depends}
 Recommends: libfrobby-doc (=${binary:Version})
-Multi-Arch: same
 Description: Computations with monomial ideals (development tools)
  Frobby is a software system and project for computations with monomial ideals.
  Frobby is free software and it is intended as a vehicle for computational and
@@ -81,10 +86,10 @@
  This package contains the development tools.
 
 Package: libfrobby-doc
+Architecture: all
+Multi-Arch: foreign
 Section: doc
-Architecture: all
 Depends: ${misc:Depends}
-Multi-Arch: foreign
 Description: Computations with monomial ideals (library documentation)
  Frobby is a software system and project for computations with monomial ideals.
  Frobby is free software and it is intended as a vehicle for computational and

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,-soname,libfrobby.so.0
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# for reproducible builds of manual
export FORCE_SOURCE_DATE = 1

%:
	dh $@ --no-parallel

override_dh_auto_build:
	dh_auto_build -- all library doc develDoc \
		MODE=shared library=libfrobby.so.0.0.0

override_dh_auto_install:
	dh_auto_install -- BIN_INSTALL_DIR=/usr/bin

override_dh_install:
	dh_install -X/_formulas.

# package-has-unnecessary-activation-of-ldconfig-trigger
override_dh_makeshlibs:
	dh_makeshlibs -Xbin

=== debian/watch ===
version=4
https://github.com/Macaulay2/frobby/releases/ \
/Macaulay2/frobby/archive/v@ANY_VERSION@@ARCHIVE_EXT@

## frobby 0.9.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(frobby VERSION 0.9.5 LANGUAGES CXX)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

option(WITH_MPIR "Build with MPIR or not" off)

if(WITH_MPIR)
  find_package(MPIR 3.0.0 REQUIRED)
  set(GMP_LIBRARIES ${MPIR_LIBRARIES})
  set(GMP_INCLUDE_DIRS ${MPIR_INCLUDE_DIRS})
else()
  find_package(GMP 6.0.0 REQUIRED)
endif()

add_compile_options(
  -DPACKAGE_NAME="${PROJECT_NAME}"
  -DPACKAGE_TARNAME="${PROJECT_NAME}"
  -DPACKAGE_VERSION="${PROJECT_VERSION}"
  -DPACKAGE_STRING="${PROJECT_NAME} ${PROJECT_VERSION}"
  -DPACKAGE_BUGREPORT=""
  -DPACKAGE_URL=""
  -DPACKAGE="${PROJECT_NAME}"
  -DVERSION="${PROJECT_VERSION}"
  -Wno-uninitialized -Wno-unused-parameter
  )

add_library(frobby STATIC
  src/main.cpp
  src/display.cpp
  src/dynamicFrobeniusAlgorithm.cpp
  src/error.cpp
  src/fourti2.cpp
  src/fplllIO.cpp
  src/frobby.cpp
  src/intersect.cpp
  src/lattice.cpp
  src/randomDataGenerators.cpp
  src/stdinc.h

  src/Action.cpp
  src/ActionPrinter.cpp
  src/AlexanderDualAction.cpp
  src/AnalyzeAction.cpp
  src/Arena.cpp
  src/AssociatedPrimesAction.cpp
  src/BigIdeal.cpp
  src/BigIntVector.cpp
  src/BigPolynomial.cpp
  src/BigTermConsumer.cpp
  src/BigTermRecorder.cpp
  src/BigattiBaseCase.cpp
  src/BigattiFacade.cpp
  src/BigattiHilbertAlgorithm.cpp
  src/BigattiParams.cpp
  src/BigattiPivotStrategy.cpp
  src/BigattiState.cpp
  src/BoolParameter.cpp
  src/CanonicalCoefTermConsumer.cpp
  src/CanonicalTermConsumer.cpp
  src/CliParams.cpp
  src/CoCoA4IOHandler.cpp
  src/CoefBigTermConsumer.cpp
  src/CoefBigTermRecorder.cpp
  src/CoefTermConsumer.cpp
  src/ColumnPrinter.cpp
  src/CommonParams.cpp
  src/CommonParamsHelper.cpp
  src/CountingIOHandler.cpp
  src/DataType.cpp
  src/DebugAllocator.cpp
  src/DebugStrategy.cpp
  src/DecomRecorder.cpp
  src/Deformer.cpp
  src/DimensionAction.cpp
  src/DynamicFrobeniusAction.cpp
  src/DynamicFrobeniusFacade.cpp
  src/EulerAction.cpp
  src/EulerState.cpp
  src/Facade.cpp
  src/Fourti2IOHandler.cpp
  src/FrobbyStringStream.cpp
  src/FrobeniusAction.cpp
  src/GenerateDataFacade.cpp
  src/GenerateFrobeniusAction.cpp
  src/GenerateIdealAction.cpp
  src/HashPolynomial.cpp
  src/HelpAction.cpp
  src/HilbertAction.cpp
  src/HilbertBasecase.cpp
  src/HilbertIndependenceConsumer.cpp
  src/HilbertSlice.cpp
  src/HilbertStrategy.cpp
  src/IOFacade.cpp
  src/IOHandler.cpp
  src/IOHandlerCommon.cpp
  src/IOHandlerImpl.cpp
  src/IOParameters.cpp
  src/Ideal.cpp
  src/IdealComparator.cpp
  src/IdealConsolidator.cpp
  src/IdealFacade.cpp
  src/IdealFactory.cpp
  src/IdealOrderer.cpp
  src/IdealTree.cpp
  src/IdealWriter.cpp
  src/IndependenceSplitter.cpp
  src/InputConsumer.cpp
  src/IntegerParameter.cpp
  src/IntersectFacade.cpp
  src/IntersectionAction.cpp
  src/IrreducibleDecomAction.cpp
  src/IrreducibleIdealSplitter.cpp
  src/LatticeAlgs.cpp
  src/LatticeAnalyzeAction.cpp
  src/LatticeFacade.cpp
  src/LatticeFormatAction.cpp
  src/LocalArray.cpp
  src/Macaulay2IOHandler.cpp
  src/Matrix.cpp
  src/MaximalStandardAction.cpp
  src/Minimizer.cpp
  src/MonosIOHandler.cpp
  src/MsmSlice.cpp
  src/MsmStrategy.cpp
  src/NameFactory.cpp
  src/NewMonosIOHandler.cpp
  src/NullCoefTermConsumer.cpp
  src/NullIOHandler.cpp
  src/NullTermConsumer.cpp
  src/ObjectCache.cpp
  src/OptimizeAction.cpp
  src/OptimizeStrategy.cpp
  src/Parameter.cpp
  src/ParameterGroup.cpp
  src/Partition.cpp
  src/PivotEulerAlg.cpp
  src/PivotStrategy.cpp
  src/PolyTransformAction.cpp
  src/PolyWriter.cpp
  src/Polynomial.cpp
  src/PolynomialConsolidator.cpp
  src/PolynomialFacade.cpp
  src/PolynomialFactory.cpp
  src/PrimaryDecomAction.cpp
  src/Projection.cpp
  src/RawSquareFreeIdeal.cpp
  src/RawSquareFreeTerm.cpp
  src/SatBinomConsumer.cpp
  src/SatBinomIdeal.cpp
  src/SatBinomRecorder.cpp
  src/Scanner.cpp
  src/ScarfFacade.cpp
  src/ScarfHilbertAlgorithm.cpp
  src/ScarfParams.cpp
  src/SingularIOHandler.cpp
  src/SizeMaxIndepSetAlg.cpp
  src/Slice.cpp
  src/SliceFacade.cpp
  src/SliceLikeParams.cpp
  src/SliceParameters.cpp
  src/SliceParams.cpp
  src/SliceStrategy.cpp
  src/SliceStrategyCommon.cpp
  src/SplitStrategy.cpp
  src/SquareFreeIdeal.cpp
  src/StatisticsStrategy.cpp
  src/StringParameter.cpp
  src/Task.cpp
  src/TaskEngine.cpp
  src/Term.cpp
  src/TermConsumer.cpp
  src/TermExtra.cpp
  src/TermGrader.cpp
  src/TermPredicate.cpp
  src/TermTranslator.cpp
  src/TestAction.cpp
  src/Timer.cpp
  src/TotalDegreeCoefTermConsumer.cpp
  src/TransformAction.cpp
  src/TranslatingCoefTermConsumer.cpp
  src/TranslatingTermConsumer.cpp
  src/UniHashPolynomial.cpp
  src/VarNames.cpp
  src/VarSorter.cpp

  src/test/Test.cpp
  src/test/TestCase.cpp
  src/test/TestQualifier.cpp
  src/test/TestRunner.cpp
  src/test/TestSorter.cpp
  src/test/TestSuite.cpp
  src/test/TestVisitor.cpp
  src/test/asserts.cpp
  src/test/macroes.cpp
  )

target_link_libraries(frobby ${GMP_LIBRARIES})
target_include_directories(frobby PUBLIC
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
  $<BUILD_INTERFACE:${GMP_INCLUDE_DIRS}>
  $<INSTALL_INTERFACE:include>
  )

set_target_properties(frobby PROPERTIES PUBLIC_HEADER src/frobby.h)
install(TARGETS frobby LIBRARY DESTINATION lib)
install(FILES GPL-header COPYING DESTINATION licenses/frobby)

include(CTest)
if(BUILD_TESTING)
  add_executable(frobby-tests
    src/ArenaTest.cpp
    src/IdealTest.cpp
    src/LibAlexanderDualTest.cpp
    src/LibAssociatedPrimesTest.cpp
    src/LibDimensionTest.cpp
    src/LibHilbertPoincareTest.cpp
    src/LibIrreducibleDecomTest.cpp
    src/LibMaxStdTest.cpp
    src/LibPrimaryDecomTest.cpp
    src/LibStdProgramTest.cpp
    src/LibTest.cpp
    src/MatrixTest.cpp
    src/OptimizeStrategyTest.cpp
    src/RawSquareFreeIdealTest.cpp
    src/RawSquareFreeTermTest.cpp
    src/TermGraderTest.cpp
    src/TermTest.cpp
    src/TermTranslatorTest.cpp
    )
  target_link_libraries(frobby-tests frobby)

  # TODO: see testing section in Makefile
  # add_test()
endif()

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,23 @@
 # ***** Variables
+
+
+# ========================
+# >>>>>  GMP set-up  <<<<<
+# ========================
+# For GMP set **both**  GMP_INC_DIR  **and**  ldflags_for_gmp
+# If you have a system installation of GMP with C++ support use next 2 lines:
+# GMP_INC_DIR=
+# ldflags_for_gmp=-lgmpxx -lgmp
+GMP_INC_DIR=/usr/local/include
+ldflags_for_gmp=-L/usr/local/lib -lgmpxx -lgmp
+
+
 
 rawSources := main.cpp Action.cpp IOParameters.cpp						\
   IrreducibleDecomAction.cpp fplllIO.cpp IOHandler.cpp fourti2.cpp		\
   randomDataGenerators.cpp MonosIOHandler.cpp BigIdeal.cpp				\
   TransformAction.cpp Macaulay2IOHandler.cpp NewMonosIOHandler.cpp		\
-  HelpAction.cpp stdinc.cpp DynamicFrobeniusAction.cpp					\
+  HelpAction.cpp DynamicFrobeniusAction.cpp					\
   dynamicFrobeniusAlgorithm.cpp GenerateIdealAction.cpp					\
   GenerateFrobeniusAction.cpp intersect.cpp FrobeniusAction.cpp			\
   Facade.cpp IOFacade.cpp DynamicFrobeniusFacade.cpp					\
@@ -213,7 +226,7 @@
 	rm -f bin/$(library)
 ifeq ($(MODE), shared)
 	$(CXX) -shared -o bin/$(library) $(ldflags) \
-	  $(patsubst $(outdir)main.o,,$(objs))
+	  $(patsubst $(outdir)main.o,,$(objs)) -lgmp -lgmpxx
 else
 	ar crs bin/$(library) $(patsubst $(outdir)main.o,,$(objs))
 	$(RANLIB) bin/$(library)
@@ -239,13 +252,15 @@
 
 -include $(objs:.o=.d)
 
+PREFIX ?= /usr/local
+MAN1DIR ?= $(PREFIX)/share/man/man1
+
 # Installation.
 install:
-	if [ "`uname|grep CYGWIN`" = "" ]; then \
-		sudo install bin/frobby $(BIN_INSTALL_DIR); \
-	else \
-		install bin/frobby $(BIN_INSTALL_DIR); \
-	fi  # Cygwin has no sudo
+	install -d $(DESTDIR)$(BIN_INSTALL_DIR)
+	install bin/frobby $(DESTDIR)$(BIN_INSTALL_DIR)
+	mkdir -p $(DESTDIR)$(MAN1DIR)
+	install -m 644 doc/frobby.1 $(DESTDIR)$(MAN1DIR)
 
 # ***** Documentation
 
@@ -333,15 +348,3 @@
 	  exit 1; \
 	fi
 
-	if [ ! -d sage/ ]; then echo "sage/ directory not found."; exit 1; fi
-# Ensure that previous builds have been cleaned up
-	rm -rf bin/sagetmp bin/frobby-$(VER) bin/frobby-$(VER).spkg
-
-	hg clone sage bin/sagetmp
-
-	mkdir bin/sagetmp/src
-	cp -r COPYING Makefile src test bin/sagetmp/src
-
-	mv bin/sagetmp bin/frobby-$(VER)
-	cd bin/; $(SAGE_ROOT)/sage -pkg `pwd`/frobby-$(VER)
-	rm -rf bin/frobby-$(VER)

=== debian/changelog ===
frobby (0.9.5-4) unstable; urgency=medium

  * debian/control
    - Update Maintainer to Debian Math Team.
    - Update Vcs-* fields (science-team -> math-team).
    - Add 4ti2 to Suggests; needed for frobgrob script.
  * debian/copyright
    - Use leading spaces instead of tabs.
    - Update my copyright years.
  * debian/frobby.install
    - Install frobgrob script.
  * debian/libfrobby-dev.install
    - Install static library.
  * debian/patches/frobgrob.patch
    - New patch; fix paths to frobby and 4ti2 in frobgrob script.
  * debian/README.Debian
    - New file; document frobgrob script.
  * debian/rules
    - Switch override_dh_install target to override_dh_installdocs;
      properly exclude the _formulas.* files that were causing
      reproducibility issues.
    - Fix computation of soversion.
    - Build static library.
  * debian/salsa-ci.yml
    - Allow reprotest to fail.
  * debian/tests/control
    - Add autopkgtest for frobgrob script.
  * debian/watch
    - Upload download URL (releases -> tags).

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 15 Nov 2021 22:29:37 -0500

frobby (0.9.5-3) unstable; urgency=medium

  * debian/control
    - Add libgmp-dev to Depends for libfrobby-dev since frobby.h contains
      "#include <gmp.h>".
    - Reformat using wrap-and-sort.

 -- Doug Torrance <dtorrance@piedmont.edu>  Fri, 20 Aug 2021 13:26:53 -0400

frobby (0.9.5-2) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.6.0.
  * debian/libfrobby*.links
    - Remove files; replace with override_dh_link target in d/rules so we
      can take advantage of variables containing soname version
      information.
  * debian/patches/frobby-version
    - New patch; go back to using constants::version instead of
      frobby_version (Closes: #992432).
  * debian/rules
    - Use variables for soname version to simplify maintenance.
  * debian/tests/{control,frobby-version.cpp}
    - New CI test to test compiling and linking against libfrobby.

 -- Doug Torrance <dtorrance@piedmont.edu>  Wed, 18 Aug 2021 11:36:49 -0400

frobby (0.9.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/clean
    - New file; remove some cruft from running tests.
  * debian/control
    - Bump Standards-Version to 4.5.1.
    - Fix extended-description-line-too-long Lintian warning
    - Drop dh-exec from Build-Depends.
    - Drop various build dependencies that were needed to build
      PDF/PostScript developer's documentation.
    - Add Build-Depends-Arch and Build-Depends-Indep to separate
      dependencies for building frobby itself and its manual from those
      needed for the developer's documentation.
  * debian/frobby.1
    - Remove file; manpage added upstream.
  * debian/frobby.doc{s,-base}
    - Stop shipping redundant PostScript documentation.
  * debian/frobby.manpages
    - Update path to upstream manpage.
  * debian/libfrobby{-dev.links,0.install,0.links}
    - Drop executable bit and dh-exec shebang; no longer necessary to use
      DEB_HOST_MULTIARCH substitution variable debhelper 13.
  * debian/libfrobby-doc.doc{s,-base}
    - Stop shipping redundant PDF and PostScript developer's documentation.
  * debian/patches
    - Remove directory; patches applied upstream.
  * debian/rules
    - New override_dh_auto_{test,install}-indep targets; skip these when
      just building the developer's documentation.  Also switch
      override_dh_auto_install to override_dh_auto_install-arch.
    - Only set soname in LDFLAGS when building library; this makes the
      override_dh_makeshlibs target unnecessary so we drop it.
  * debian/watch
    - Use more general regular expression for Github link.

 -- Doug Torrance <dtorrance@piedmont.edu>  Tue, 17 Aug 2021 17:33:24 -0400

=== debian/control ===
--- 
+++ 
@@ -1,30 +1,22 @@
 Source: frobby
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Section: math
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               dh-exec,
-               doxygen-latex,
-               g++ (>= 4:7),
-               ghostscript,
-               libgmp-dev,
-               texlive-font-utils,
-               texlive-fonts-recommended,
-               texlive-latex-base,
-               texlive-latex-extra,
-               texlive-latex-recommended,
-Standards-Version: 4.5.0
-Vcs-Browser: https://salsa.debian.org/science-team/frobby
-Vcs-Git: https://salsa.debian.org/science-team/frobby.git
+Build-Depends: debhelper-compat (= 13)
+Build-Depends-Arch: g++ (>= 4:7), libgmp-dev, texlive-latex-base
+Build-Depends-Indep: doxygen
+Standards-Version: 4.6.0
+Vcs-Browser: https://salsa.debian.org/math-team/frobby
+Vcs-Git: https://salsa.debian.org/math-team/frobby.git
 Homepage: https://github.com/Macaulay2/frobby
 Rules-Requires-Root: no
 
 Package: frobby
 Architecture: any
 Multi-Arch: foreign
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Suggests: 4ti2
 Description: Computations with monomial ideals
  Frobby is a software system and project for computations with monomial ideals.
  Frobby is free software and it is intended as a vehicle for computational and
@@ -34,8 +26,8 @@
  maximal standard monomials, combinatorial optimization on monomial ideals,
  primary decomposition, irreducible decomposition, Alexander dual, associated
  primes, minimization and intersection of monomial ideals as well as the
- computation of Frobenius problems (using 4ti2) with very large numbers. Frobby
- is also able to translate between formats that can be used with several
+ computation of Frobenius problems (using 4ti2) with very mmlarge numbers.
+ Frobby is also able to translate between formats that can be used with several
  different computer systems, such as Macaulay 2, Monos, 4ti2, CoCoA4 and
  Singular. Thus Frobby can be used with any of those systems.
 
@@ -43,8 +35,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Computations with monomial ideals (shared library)
  Frobby is a software system and project for computations with monomial ideals.
@@ -66,8 +57,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libfrobby0 (=${binary:Version}),
-         ${misc:Depends}
+Depends: libfrobby0 (=${binary:Version}), libgmp-dev, ${misc:Depends}
 Recommends: libfrobby-doc (=${binary:Version})
 Description: Computations with monomial ideals (development tools)
  Frobby is a software system and project for computations with monomial ideals.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# for reproducible builds of manual
export FORCE_SOURCE_DATE = 1

%:
	dh $@ --no-parallel

CURRENT    = 0
REVISION   = 0
AGE        = 0
SOVERSION := $(shell expr $(CURRENT) - $(AGE))
VERSION   := $(SOVERSION).$(AGE).$(REVISION)

override_dh_auto_build-arch:
	$(MAKE) all
	$(MAKE) library RANLIB=ranlib # static library
	$(MAKE) library MODE=shared \
		library=libfrobby.so.$(VERSION) \
		LDFLAGS="$(LDFLAGS) -Wl,-soname,libfrobby.so.$(SOVERSION)"
	$(MAKE) docPdf

override_dh_auto_build-indep:
	$(MAKE) develDocHtml

override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_auto_install-arch:
	dh_auto_install -- BIN_INSTALL_DIR=/usr/bin

override_dh_installdocs:
	dh_installdocs -X/_formulas.

override_dh_link:
	dh_link -plibfrobby$(SOVERSION) \
		usr/lib/$(DEB_HOST_MULTIARCH)/libfrobby.so.$(VERSION) \
		usr/lib/$(DEB_HOST_MULTIARCH)/libfrobby.so.$(SOVERSION)
	dh_link -plibfrobby-dev \
		usr/lib/$(DEB_HOST_MULTIARCH)/libfrobby.so.$(VERSION) \
		usr/lib/$(DEB_HOST_MULTIARCH)/libfrobby.so
	dh_link --remaining-packages

=== debian/tests/control ===
Tests: runtests
Depends: frobby

Test-Command: cp debian/tests/frobby-version.cpp $AUTOPKGTEST_TMP &&
 cd $AUTOPKGTEST_TMP &&
 g++ frobby-version.cpp -o frobby-version -lfrobby &&
 ./frobby-version
Depends: g++, libfrobby-dev

# frobgrob example from manual
Test-Command: cd $AUTOPKGTEST_TMP &&
 echo 1234567890001 348461546433 6484646532513541
 45464188888115164 1561484651561864468465310 > frob2 &&
 /usr/share/frobby/frobgrob frob2 | diff - <(echo 15111053020091472900)
Depends: 4ti2, frobby
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/Macaulay2/frobby/tags/ .*/v@ANY_VERSION@@ARCHIVE_EXT@
